class HeldBase {}

class Held: HeldBase {
}

class Holder {
  weak var value: HeldBase? {
    willSet {
      print("willSet(value=\(newValue))")
    }
    didSet {
      print("didSet(value=\(value))")
    }
  }

  func testFunc() {
    var held: HeldBase = Held()
    self.value = held

    if let _ = self.value {
      print("t1: has value")
    } else {
      print("t1: no value!")
    }

    held = HeldBase()

    if let _ = self.value {
      print("t2: has value!")
    } else {
      print("t2: no value")
    }
  }
}

var holder = Holder()
holder.testFunc()

var holder2 = Holder()
var testValue: HeldBase = Held()

holder2.value = testValue

if let _ = holder2.value {
  print("t3: has value")
} else {
  print("t3: no value!")
}

testValue = HeldBase()

if let _ = holder2.value {
  print("t4: has value!")
} else {
  print("t4: no value")
}

